var CANVAS_WIDTH = 768;
var CANVAS_HEIGHT = 1024;
var ORIENTATION = "1"

! function(a) {
    var b = /iPhone/i,
        c = /iPod/i,
        d = /iPad/i,
        e = /(?=.*\bAndroid\b)(?=.*\bMobile\b)/i,
        f = /Android/i,
        g = /(?=.*\bAndroid\b)(?=.*\bSD4930UR\b)/i,
        h = /(?=.*\bAndroid\b)(?=.*\b(?:KFOT|KFTT|KFJWI|KFJWA|KFSOWI|KFTHWI|KFTHWA|KFAPWI|KFAPWA|KFARWI|KFASWI|KFSAWI|KFSAWA)\b)/i,
        i = /IEMobile/i,
        j = /(?=.*\bWindows\b)(?=.*\bARM\b)/i,
        k = /BlackBerry/i,
        l = /BB10/i,
        m = /Opera Mini/i,
        n = /(CriOS|Chrome)(?=.*\bMobile\b)/i,
        o = /(?=.*\bFirefox\b)(?=.*\bMobile\b)/i,
        p = new RegExp("(?:Nexus 7|BNTV250|Kindle Fire|Silk|GT-P1000)", "i"),
        q = function(a, b) {
            return a.test(b)
        },
        r = function(a) {
            var r = a || navigator.userAgent,
                s = r.split("[FBAN");
            return "undefined" != typeof s[1] && (r = s[0]), s = r.split("Twitter"), "undefined" != typeof s[1] && (r = s[0]), this.apple = {
                phone: q(b, r),
                ipod: q(c, r),
                tablet: !q(b, r) && q(d, r),
                device: q(b, r) || q(c, r) || q(d, r)
            }, this.amazon = {
                phone: q(g, r),
                tablet: !q(g, r) && q(h, r),
                device: q(g, r) || q(h, r)
            }, this.android = {
                phone: q(g, r) || q(e, r),
                tablet: !q(g, r) && !q(e, r) && (q(h, r) || q(f, r)),
                device: q(g, r) || q(h, r) || q(e, r) || q(f, r)
            }, this.windows = {
                phone: q(i, r),
                tablet: q(j, r),
                device: q(i, r) || q(j, r)
            }, this.other = {
                blackberry: q(k, r),
                blackberry10: q(l, r),
                opera: q(m, r),
                firefox: q(o, r),
                chrome: q(n, r),
                device: q(k, r) || q(l, r) || q(m, r) || q(o, r) || q(n, r)
            }, this.seven_inch = q(p, r), this.any = this.apple.device || this.android.device || this.windows.device || this.other.device || this.seven_inch, this.phone = this.apple.phone || this.android.phone || this.windows.phone, this.tablet = this.apple.tablet || this.android.tablet || this.windows.tablet, "undefined" == typeof window ? this : void 0
        },
        s = function() {
            var a = new r;
            return a.Class = r, a
        };
    "undefined" != typeof module && module.exports && "undefined" == typeof window ? module.exports = r : "undefined" != typeof module && module.exports && "undefined" != typeof window ? module.exports = s() : "function" == typeof define && define.amd ? define("isMobile", [], a.isMobile = s()) : a.isMobile = s()
}(this);

function resizeWithRatio(ratio)
{
    var canvas = document.getElementById("GameCanvas");

    var w = (CANVAS_WIDTH * ratio);
    var h = (CANVAS_HEIGHT * ratio);

    canvas.width = CANVAS_WIDTH;
    canvas.height = CANVAS_HEIGHT;

    canvas.style.width =  w + "px";
    canvas.style.height = h + "px";

    canvas.style.backgroundSize = "auto " + h + "px";
    canvas.style.marginTop = "0px";    
}

function resizeExactFit()
{
    var canvas = document.getElementById("GameCanvas");

    canvas.width = CANVAS_WIDTH;
    canvas.height = CANVAS_HEIGHT;

    canvas.style.width =  window.innerWidth + "px";
    canvas.style.height = window.innerHeight + "px";

    canvas.style.backgroundSize = canvas.style.width + " " + canvas.style.height;
    canvas.style.marginTop = "0px";
}

function updateSize() {
    var canvas = document.getElementById("GameCanvas");

    var ratioH = window.innerHeight / CANVAS_HEIGHT;
    var ratioW = window.innerWidth / CANVAS_WIDTH;

    var realRatio = window.innerWidth / window.innerHeight;
    var virtualRatio = CANVAS_WIDTH / CANVAS_HEIGHT;

    var ratioDiff = Math.abs(virtualRatio - realRatio);
    var maxDiff = 0.35;

    if(isMobile.any) {
        maxDiff = 0.5;
    }

    if (ratioDiff < maxDiff) {
        resizeExactFit();
    } else if (ratioH >= ratioW) {
        resizeWithRatio(ratioW);
    } else if (ratioW > ratioH) {
        resizeWithRatio(ratioH);
    }

    canvas.style.backgroundSize = canvas.style.width + " " + canvas.style.height;
    canvas.style.marginTop = ((window.innerHeight / 2) - (parseInt(canvas.style.height) / 2)) + "px";

    if (canvas.updateSize) canvas.updateSize();
}

function startGame() {
    var canvas = document.getElementById("GameCanvas");
    canvas.style.backgroundImage = "none";
    canvas.style.backgroundColor = "#000";
    canvas.style.cursor = "default";
    canvas.removeEventListener("click", startGame);
    BBMonkeyGame.Main(canvas);
}

function bootstrapGame() {
    var canvas = document.getElementById("GameCanvas");
    canvas.style.cursor = "pointer";
    canvas.style.display = "block";
    
    var mouseDown = false;
    var startY = 0;
    var canvasH = CANVAS_HEIGHT;
    var cmousemove = null;
    var cmouseup = null;
    var cmouseout = null;
    var fscreen = false;

    function eatEvent(e) {
        if (e.stopPropagation) {
            e.stopPropagation();
            e.preventDefault();
        } else {
            e.cancelBubble = true;
            e.returnValue = false;
        }
    }

    window.onmousemove = function(e) {
        if (mouseDown) {
            var dy = e.clientY - startY;
            startY += dy;
            canvasH += dy;
            updateSize();
            eatEvent(e);
        }
    }

    window.onmouseup = function(e) {
        if (mouseDown) {
            canvas.onmousemove = cmousemove;
            canvas.onmouseup = cmouseup;
            canvas.onmouseout = cmouseout;
            mouseDown = false;
            eatEvent(e);
        }
    }

    window.onresize = function(e) {
        updateSize();
    }

    canvas.onfullscreenchange = function(e) {
        updateSize();
    }

    canvas.onwebkitfullscreenchange = function(e) {
        updateSize();
    }

    canvas.onmozfullscreenchange = function(e) {
        updateSize();
    }

    window.onOrientationChange = function() { updateSize; }

    updateSize();

    canvas.addEventListener("click", startGame);    
}
